package gz.cyberbrain.cyberhotel.controller;

import gz.cyberbrain.cyberhotel.controller.util.ErrorItem;
import gz.cyberbrain.cyberhotel.controller.util.ErrorsHandler;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.SeasonTariffiedException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.io.Serializable;
import java.util.Collection;
import java.util.HashMap;
import java.util.Vector;

public class SeasonListAdapter extends ListAdapter {

	public SaveAdapter getCreator() {
		return new SeasonCreator();
	}

	public SaveAdapter getUpdater() {
		return new SeasonUpdater();
	}

	public Vector load() {
		Vector list = new Vector();

		list = SeasonController.seasonList();

		return list;
	}

	public void delete(Serializable id) {

		try {

			SeasonController.deleteSeason((Long) id);

		} catch (SeasonTariffiedException e) {
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("delete"));
		} catch (InstanceNotFoundException e) {
		} catch (InternalErrorException e) {
		}

	}

	public HashMap find(Serializable id) {
		HashMap map = new HashMap();
		try {
			map = SeasonController.findSeason((Long) id);
		} catch (InstanceNotFoundException e) {
		} catch (InternalErrorException e) {}
		return map;
	}

	public void updateDays(Collection days, Long seasonId) {		
		SeasonController.updateDaySeasons(days, seasonId);		
	}

	public void removeSeasons(Collection days) {
		try {
			SeasonController.removeDaySeasons(days);
		} catch (InstanceNotFoundException e) {
			e.printStackTrace();
		} catch (SeasonTariffiedException e) {
			System.out.println("SeasonTariffied");
			ErrorsHandler.clear();
			ErrorsHandler.add(new ErrorItem("seasonTariffied"));			
		} catch (InternalErrorException e) {
			e.printStackTrace();
		}		
	}
	public Vector seasonDays(Long seasonId) {
		return SeasonController.seasonDayList(seasonId);
	}
}
