package gz.cyberbrain.cyberhotel.model.client.dao;

import gz.cyberbrain.cyberhotel.model.client.to.ClientTo;
import gz.cyberbrain.cyberhotel.model.client.to.CompanyTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;
import java.util.Vector;

public class CompanySpringDao extends AbstractSpringDao implements ClientDao {

	public CompanySpringDao() {
		super(CompanyTo.class);
	}	

	public CompanyTo create(ClientTo companyTo) throws InternalErrorException {		

		return (CompanyTo) super.save(companyTo);

	}

	public ClientTo find(Long clientId) throws InstanceNotFoundException, InternalErrorException {

		ClientTo clientTo = (ClientTo) super.find(clientId);
		return clientTo;

	}

	public void update(ClientTo companyTo) throws InternalErrorException {		

		super.update(companyTo);

	}

	public void remove(ClientTo companyTo) throws InternalErrorException {

		super.delete(companyTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allCompanies";
		return super.findByQuery(queryName);

	}

	public Collection findAllIds() throws InternalErrorException {

		String queryName = "allCompanyIds";
		return super.findByQuery(queryName);
	}

	public Collection findByKeys (Vector keys) throws InternalErrorException {

		String queryString = "from CompanyTo as company where";

		for (int i=0;i<keys.size();i++)
			if(i==keys.size()-1)
				queryString += " company.name like "+ (String) keys.get(i);
			else
				queryString += " company.name like " + (String) keys.get(i) + " and";

		return super.findByQuery(queryString);

	}

	public boolean existOwes(Long clientId) throws InternalErrorException {
		return false;
	}

	public boolean existRequests(Long clientId) throws InternalErrorException {
		return false;
	}

	public boolean isPayer (Long clientId) throws InternalErrorException {
		String queryName = "clientPayments";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}

	public boolean existInvoices(Long clientId) throws InternalErrorException {
		String queryName = "clientInvoices";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}

	public boolean takesPartInReservation(Long clientId) throws InternalErrorException {
		String queryName = "companyReservations";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}

}
