package gz.cyberbrain.cyberhotel.model.client.dao;

import gz.cyberbrain.cyberhotel.model.client.to.ClientTo;
import gz.cyberbrain.cyberhotel.model.client.to.ParticularTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Collection;
import java.util.Vector;

public class ParticularSpringDao extends AbstractSpringDao implements ClientDao {

	public ParticularSpringDao() {
		super(ParticularTo.class);
	}	

	public ParticularTo create(ClientTo particularTo) throws InternalErrorException {		

		return (ParticularTo) super.save(particularTo);

	}

	public ClientTo find(Long clientId) throws InstanceNotFoundException, InternalErrorException {

		ClientTo clientTo = (ClientTo) super.find(clientId);
		return clientTo;

	}

	public void update(ClientTo particularTo) throws InternalErrorException {		

		super.update(particularTo);

	}

	public void remove(ClientTo particularTo) throws InternalErrorException {

		super.delete(particularTo);

	}

	public Collection findAll() throws InternalErrorException {

		String queryName = "allParticulars";
		return super.findByQuery(queryName);

	}

	public Collection findAllIds() throws InternalErrorException {

		String queryName = "allParticularIds";
		return super.findByQuery(queryName);
	}

	public Collection findByKeys (Vector keys) throws InternalErrorException {

		String queryString = "from ParticularTo as particular where";

		for (int i=0;i<keys.size();i++)
			if(i==keys.size()-1)
				queryString += " particular.name like "+ (String) keys.get(i);
			else
				queryString += " particular.name like " + (String) keys.get(i) + " and";

		return super.findByQuery(queryString);

	}
	
	public boolean existOwes(Long clientId) throws InternalErrorException {
		String queryName = "clientOwes";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}
	
	public boolean existRequests(Long clientId) throws InternalErrorException {
		String queryName = "clientRequests";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}

	public boolean isPayer (Long clientId) throws InternalErrorException {
		String queryName = "clientPayments";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}
	
	public boolean existInvoices(Long clientId) throws InternalErrorException {
		String queryName = "clientInvoices";
		return (!super.findByAttribute(queryName, clientId).isEmpty());
	}
	
	public boolean takesPartInReservation(Long clientId) throws InternalErrorException {
		return false;
	}
	
}
