package gz.cyberbrain.cyberhotel.model.concept.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.util.money.MoneyOperations;

import java.io.Serializable;
import java.math.BigDecimal;

public class ConceptTo implements Identifiable {
	
	private static final long serialVersionUID = 2073647277529852636L;
	private String conceptCode;
	private String denomination;
	private BigDecimal vat;
	
	public ConceptTo(){}
	
	public ConceptTo(String conceptCode, String denomination, BigDecimal vat) {		
		this.conceptCode = conceptCode;
		this.denomination = denomination;
		this.vat = MoneyOperations.getDecimalReduction(vat);
	}
	
	public Serializable getId(){
		return conceptCode;
	}

	public String getConceptCode() {
		return conceptCode;
	}

	public void setConceptCode(String conceptCode) {
		this.conceptCode = conceptCode;
	}

	public String getDenomination() {
		return denomination;
	}

	public void setDenomination(String denomination) {
		this.denomination = denomination;
	}

	public BigDecimal getVat() {
		return vat;
	}

	public void setVat(BigDecimal vat) {
		this.vat = vat;
	}		
	
}
