package gz.cyberbrain.cyberhotel.model.configurationfacade.spring.actions;

import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeInUseException;
import gz.cyberbrain.cyberhotel.model.configurationfacade.exceptions.PriceTypeTariffiedException;
import gz.cyberbrain.cyberhotel.model.pricetype.dao.PriceTypeDao;
import gz.cyberbrain.cyberhotel.model.pricetype.to.PriceTypeTo;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

public class DeletePriceTypeAction {

	private PriceTypeTo priceTypeTo;
	private PriceTypeDao priceTypeDao;
	
	public DeletePriceTypeAction (PriceTypeTo priceTypeTo, PriceTypeDao priceTypeDao) {
		
		this.priceTypeTo = priceTypeTo;
		this.priceTypeDao = priceTypeDao;
		
	}
	
	public void execute() throws PriceTypeInUseException, PriceTypeTariffiedException, InternalErrorException {
		
		if (priceTypeDao.existRequests(priceTypeTo.getPriceTypeCode())) throw new PriceTypeInUseException(priceTypeTo);
		if (priceTypeDao.isTariffied(priceTypeTo.getPriceTypeCode())) throw new PriceTypeTariffiedException(priceTypeTo);
		
		priceTypeDao.remove(priceTypeTo);
		
	}
	
}
