package gz.cyberbrain.cyberhotel.model.reservation.dao;

import gz.cyberbrain.cyberhotel.model.reservation.to.ReservationTo;
import gz.cyberbrain.cyberhotel.model.spring.dao.AbstractSpringDao;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InstanceNotFoundException;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.util.Calendar;
import java.util.Collection;

public class ReservationSpringDao extends AbstractSpringDao implements ReservationDao {

	public ReservationSpringDao() {
		super(ReservationTo.class);
	}	

	public ReservationTo create(ReservationTo reservationTo) throws InternalErrorException {		

		return (ReservationTo) super.save(reservationTo);

	}

	public ReservationTo find(Long reservationId) throws InstanceNotFoundException, InternalErrorException {

		ReservationTo reservationTo = (ReservationTo) super.find(reservationId);
		return reservationTo;

	}

	public void update(ReservationTo reservationTo) throws InternalErrorException {		

		super.update(reservationTo);

	}

	public void remove(ReservationTo reservationTo) throws InternalErrorException {

			super.delete(reservationTo);
	
	}
	
	public Collection findAll() throws InternalErrorException {
		
		String queryName = "allReservations";
		return super.findByQuery(queryName);
		
	}
	
	public Collection findByStatus(String reservationStatus) throws InternalErrorException {
		
		String queryName = "reservationByStatus";
		return super.findByAttribute(queryName, reservationStatus);
		
	}
	
	public Collection findByDates(Calendar []attributes) throws InternalErrorException { 
		
		String queryName = "reservationByDates";
		return super.findByAttributes(queryName, attributes);
		
	}
	
	public Collection findRequests(Long reservationId) throws InternalErrorException {
		
		String queryName = "reservationRequests";
		return super.findByAttribute(queryName, reservationId);
		
	}

	public Collection findReservationOwes(Long reservationId) throws InternalErrorException {
		String queryName = "reservationOwes";
		Long []attributes = {reservationId, reservationId, reservationId};
		return super.findByAttributes(queryName, attributes);
	}

}
