package gz.cyberbrain.cyberhotel.model.reservation.to;

import gz.cyberbrain.cyberhotel.model.identifiable.Identifiable;
import gz.cyberbrain.cyberhotel.model.util.dates.DateOperations;

import java.io.Serializable;
import java.util.Calendar;

public class ReservationTo implements Identifiable {
	
	private static final long serialVersionUID = -2726810608345421412L;
	private Long reservationId;
	private String reservatorName;
	private String reservatorCif;
	private String reservatorAccount;
	private String reservatorCard;
	private String reservatorPhone;
	private String reservationStatus;
	private Calendar incomingDate;
	private Calendar expectedOutgoingDate;
	private Calendar trueOutgoingDate;
	private Long payer;
	private Long agency;
	private Long company;
	private String notes;
	private boolean byHours;
	
	public ReservationTo(){}
	
	public ReservationTo(Long reservationId, String reservatorName, String reservatorCif, String reservatorAccount, String reservatorCard, String reservatorPhone, String reservationStatus, Calendar incomingDate, Calendar expectedOutgoingDate, Calendar trueOutgoingDate, Long payer, Long agency, Long company, String notes, boolean byHours) {		
		this.reservationId = reservationId;
		this.reservatorName = reservatorName;
		this.reservatorCif = reservatorCif;
		this.reservatorAccount = reservatorAccount;
		this.reservatorCard = reservatorCard;
		this.reservatorPhone = reservatorPhone;
		this.reservationStatus = reservationStatus;
		this.incomingDate = DateOperations.getDateWithoutMilliseconds(incomingDate);
		this.expectedOutgoingDate = DateOperations.getDateWithoutMilliseconds(expectedOutgoingDate);
		this.trueOutgoingDate = DateOperations.getDateWithoutMilliseconds(trueOutgoingDate);
		this.payer = payer;
		this.agency = agency;
		this.company = company;		
		this.notes = notes;
		this.byHours = byHours;
	}
	
	public Serializable getId(){
		return reservationId;
	}

	public Long getAgency() {
		return agency;
	}

	public void setAgency(Long agency) {
		this.agency = agency;
	}

	public boolean getByHours() {
		return byHours;
	}
	
	public void setByHours(boolean byHours) {
		this.byHours = byHours;
	}
	
	public Long getCompany() {
		return company;
	}

	public void setCompany(Long company) {
		this.company = company;
	}

	public Calendar getExpectedOutgoingDate() {
		return expectedOutgoingDate;
	}

	public void setExpectedOutgoingDate(Calendar expectedOutgoingDate) {
		this.expectedOutgoingDate = expectedOutgoingDate;
	}

	public Calendar getIncomingDate() {
		return incomingDate;
	}

	public void setIncomingDate(Calendar incomingDate) {
		this.incomingDate = incomingDate;
	}

	public String getNotes() {
		return notes;
	}

	public void setNotes(String notes) {
		this.notes = notes;
	}
	
	public Long getPayer() {
		return payer;
	}

	public void setPayer(Long payer) {
		this.payer = payer;
	}

	public String getReservationStatus() {
		return reservationStatus;
	}

	public void setReservationStatus(String reservationStatus) {
		this.reservationStatus = reservationStatus;
	}

	public String getReservatorAccount() {
		return reservatorAccount;
	}

	public void setReservatorAccount(String reservatorAccount) {
		this.reservatorAccount = reservatorAccount;
	}

	public String getReservatorCard() {
		return reservatorCard;
	}

	public void setReservatorCard(String reservatorCard) {
		this.reservatorCard = reservatorCard;
	}

	public String getReservatorCif() {
		return reservatorCif;
	}

	public void setReservatorCif(String reservatorCif) {
		this.reservatorCif = reservatorCif;
	}

	public String getReservatorName() {
		return reservatorName;
	}

	public void setReservatorName(String reservatorName) {
		this.reservatorName = reservatorName;
	}

	public String getReservatorPhone() {
		return reservatorPhone;
	}

	public void setReservatorPhone(String reservatorPhone) {
		this.reservatorPhone = reservatorPhone;
	}

	public Calendar getTrueOutgoingDate() {
		return trueOutgoingDate;
	}

	public void setTrueOutgoingDate(Calendar trueOutgoingDate) {
		this.trueOutgoingDate = trueOutgoingDate;
	}

	public Long getReservationId() {
		return reservationId;
	}

	public void setReservationId(Long reservationId) {
		this.reservationId = reservationId;
	}		
	
}
