package gz.cyberbrain.cyberhotel.model.util.config;

import gz.cyberbrain.cyberhotel.model.spring.dao.SpringDaoFactory;
import gz.cyberbrain.cyberhotel.model.util.exceptions.InternalErrorException;

import java.math.BigDecimal;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.List;

import javax.sql.DataSource;

import org.springframework.jdbc.object.MappingSqlQuery;

public class ConfigurationHandler extends MappingSqlQuery {

	private static ConfigurationHandler conf;

	public static Boolean EXTRA_TAX;
	public static BigDecimal EXTRA_TAX_AMMOUNT;
	public static String EXTRA_TAX_CONCEPT;
	public static Boolean ACOMMODATION_BY_HOURS;
	public static Long CLEANING_RATE;
	public static Long DISINFECTION_RATE;
	public static Calendar DAY_START_TIME;
	public static BigDecimal COIN;
	public static String STAY_CONCEPT;
	public static String LOCALE;

	private ConfigurationHandler(){};

	private ConfigurationHandler(DataSource ds){

		super(ds, "select tasaExtra, cantTasa, cargoTasa, aloxPorHoras, diasLimp, diasDesinf, inicioDia, moeda, estancia, idioma " +
		"from config");
		
		compile();
		
	}

	public static List init() throws InternalErrorException {

		try {

			DataSource ds = SpringDaoFactory.getDataSource();

			if (conf == null) conf = new ConfigurationHandler(ds);
		
			return conf.execute();			
			
		} catch (Exception e) {
			throw new InternalErrorException(e);
		}
	}

	public Object mapRow(ResultSet rs, int rowNumber) throws SQLException {

		EXTRA_TAX = (Boolean) rs.getObject("tasaExtra");		
		EXTRA_TAX_AMMOUNT = (BigDecimal) rs.getObject("cantTasa");
		EXTRA_TAX_CONCEPT = (String) rs.getObject("cargoTasa");
		ACOMMODATION_BY_HOURS = (Boolean) rs.getObject("aloxPorHoras");
		CLEANING_RATE = (Long) rs.getObject("diasLimp");
		DISINFECTION_RATE = (Long) rs.getObject("diasDesinf");
		DAY_START_TIME = (Calendar) rs.getObject("inicioDia");
		COIN = (BigDecimal) rs.getObject("moeda");
		STAY_CONCEPT = (String) rs.getObject("estancia");
		LOCALE = (String) rs.getObject("idioma");
		
		return conf;
		
	}

}
