package gz.cyberbrain.cyberhotel.view.swing.main;

import java.awt.Color;

import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import gz.cyberbrain.cyberhotel.view.swing.login.LoginWindow;
import gz.cyberbrain.cyberhotel.view.swing.start.SplashScreen;
import gz.cyberbrain.cyberhotel.view.swing.util.locale.Locale;

public class Main {

	public static void main (String [] args) {

		SplashScreen splashScreen = SplashScreen.getInstance();
		splashScreen.setVisible(true);
		splashScreen.setInfoText(Locale.get("SplashScreen.lookAndFeel"));
		splashScreen.increase(10);
				
		try {
	
			// Set System L&F
			UIManager.setLookAndFeel(
					UIManager.getSystemLookAndFeelClassName());
			
			UIManager.put("ComboBox.disabledForeground", Color.BLACK);
			
		} 
		catch (UnsupportedLookAndFeelException e) {
			e.printStackTrace();
		}
		catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		catch (InstantiationException e) {
			e.printStackTrace();
		}
		catch (IllegalAccessException e) {
			e.printStackTrace();
		}
		
		
		splashScreen.increase(20);
		splashScreen.setInfoText(Locale.get("SplashScreen.graphicsEnvironment"));
		LoginWindow loginWindow = LoginWindow.getInstance();	
		splashScreen.hideSplash();
		loginWindow.setVisible(true);

	}

}
